/**************************************************************

   Program Title:  test.c
   
   Program Name: test.c 		  Version: 0.01
   
   Author:  WR	  				  Date:  March 03, 2008
   
   Compiled with ImageCraft ICCAVR Standard V7.1
   
   Copyright 2004-2008, SOC Machines, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright (C) 2008 by SOC Machines, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-machines.com
 */


#include <cfg/os.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <dev/board.h>
#include <dev/urom.h>
#include <dev/nplmmc.h>
#include <dev/sbimmc.h>
#include <fs/phatfs.h>
#include <sys/version.h>
#include <sys/thread.h>
#include <sys/timer.h>
#include <sys/heap.h>
#include <sys/confnet.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <net/route.h>
#include <pro/httpd.h>
#include <pro/dhcp.h>
#include <pro/ssi.h>
#include <pro/asp.h>
#include <pro/discover.h>



#include "WP12_LEDs.h"
#include "WP12_Buttons.h"
#include "WP12_LCD.h"
#include "WP12_KEY.h"


int main(void)
{
    u_long baud = 115200;
    u_char i;
	unsigned char temp;
	
	

    /*
     * Initialize the uart device.
     */
    NutRegisterDevice(&DEV_DEBUG, 0, 0);
    freopen(DEV_DEBUG_NAME, "w", stdout);
    _ioctl(_fileno(stdout), UART_SETSPEED, &baud);
    NutSleep(200);
	
	
	
	printf("Amber WLP12 board\n");
	printf("SOC Robotics\n");
	printf("Use a keyboard connected to the board\n");
	printf("to write the COMM port\n");
	
	InitKEY();
	
	turnOffLED(LED1);
	turnOffLED(LED2);
	InitLED();
	InitButtons();
	Init_LCD();
    Clear_LCD();
	
    SplashScreen();
	
	
	PutStringinBuffer(0,0,"Type to the");
	PutStringinBuffer(1,0,"COMM port!");
	DisplayLCDBuffers();
 	
	while (1)
	{
	

/*
  	 	  //Uncomment block if you want to test S2
		  if (buttonState(SW2) == ON)
		  {
		   	 turnOnLED(LED2);
		  }
		  else
		  {
		   	 turnOffLED(LED2);
		  }
*/		  

		  //This section will sit and wait for a key to be pressed on the
		  //keyboard.  It will then send this to the serial port
		  temp = getKey();
		  
		  if (temp == 13)
		     temp = '\n';
			 
			 
		  printf("%c",temp);
		  
		  //Flashing an LED each time you press a key
		  turnOnLED(LED1);
		  
		  NutSleep(150);
		  
		  turnOffLED(LED1);
	}

}
